<template>
    <div class="container-fluid">
        <div class="row clearfix">
            <div class="col-12 ">
                <div class="row clearfix">
                    <div
                        v-for="i of agency"
                        :key="i.id"
                        :class="
                            editing
                                ? editing.id == i.id
                                    ? 'col-md-6'
                                    : 'd-none'
                                : 'col-md-6 col-sm-12'
                        "
                    >
                        <div
                            :class="
                                editing
                                    ? editing.id == i.id
                                        ? 'card xl-salmon member-card doctor'
                                        : 'card xl-blue member-card doctor'
                                    : 'card xl-blue member-card doctor'
                            "
                        >
                            <div class="body">
                                <div class="member-thumb">
                                    <img
                                        :src="i.logo ? i.logo : '/img/logo.png'"
                                        class="img-fluid"
                                        alt="profile-image"
                                    />
                                </div>
                                <div class="detail">
                                    <h4
                                        class="m-b-0"
                                        :class="
                                            template == 'dark'
                                                ? 'text-dark'
                                                : ''
                                        "
                                    >
                                        {{ i.nombre }}
                                    </h4>

                                    <a
                                        href="javascript:void(0);"
                                        @click="selectAgency(i)"
                                        class="btn btn-default btn-round btn-simple"
                                        >Configurar Rango de edades</a
                                    >
                                </div>
                            </div>
                        </div>
                    </div>

                    <div v-if="editing" class="col-md-6">
                        <div
                            class="card member-card doctor"
                            :class="
                                template == 'dark' ? 'bg-black' : 'xl-blue-ol'
                            "
                        >
                            <div class="body">
                                <h4>{{ editing.nombre }} <br /></h4>
                                <div v-if="createRango" class="row">
                                    <h6 class="text-center">
                                        Establecer nuevo rango de edades
                                    </h6>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <input
                                                type="number"
                                                min="0"
                                                max="100"
                                                class="form-control"
                                                v-model="newRango.min"
                                                placeholder="Edad minima"
                                            />
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <input
                                                type="number"
                                                min="0"
                                                max="100"
                                                class="form-control"
                                                v-model="newRango.max"
                                                placeholder="Edad máxima"
                                            />
                                        </div>
                                    </div>
                                    <button
                                        @click="saveRango()"
                                        class="btn btn-success btn-block"
                                    >
                                        {{
                                            successMsg
                                                ? "Salir"
                                                : "Nuevo Rango de edades"
                                        }}
                                    </button>
                                </div>
                                <table v-else class="table m-b-0 table-hover">
                                    <thead>
                                        <tr>
                                            <th>Min</th>
                                            <th>Max</th>
                                            <th></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <template v-for="ran of rango">
                                            <tr
                                                v-if="
                                                    editarRangoEdad.id == ran.id
                                                "
                                                :key="
                                                    'editarRangoEdad' + ran.id
                                                "
                                            >
                                                <td>
                                                    <input
                                                        type="number"
                                                        v-model="
                                                            editarRangoEdad.min
                                                        "
                                                        class="form-control"
                                                    />
                                                </td>
                                                <td>
                                                    <input
                                                        type="number"
                                                        v-model="
                                                            editarRangoEdad.max
                                                        "
                                                        class="form-control"
                                                    />
                                                </td>
                                                <td>
                                                    <button
                                                        @click="postEditRango()"
                                                        class="btn btn-small btn-primary"
                                                    >
                                                        <i
                                                            class="zmdi zmdi-save"
                                                        ></i>
                                                    </button>
                                                    <button
                                                        @click="
                                                            editarRangoEdad = []
                                                        "
                                                        class="btn btn-small btn-danger"
                                                    >
                                                        <i
                                                            class="zmdi zmdi-close"
                                                        ></i>
                                                    </button>
                                                </td>
                                            </tr>
                                            <tr
                                                v-else
                                                :key="'rangoEdad' + ran.id"
                                            >
                                                <td>{{ ran.min }}</td>
                                                <td>{{ ran.max }}</td>
                                                <td>
                                                    <button
                                                        @click="
                                                            editarRangoEdad = ran
                                                        "
                                                        class="btn btn-small btn-primary"
                                                    >
                                                        <i
                                                            class="zmdi zmdi-edit"
                                                        ></i>
                                                    </button>
                                                    <button
                                                        @click="
                                                            deleteRango(ran.id)
                                                        "
                                                        class="btn btn-small btn-warning"
                                                    >
                                                        <i
                                                            class="zmdi zmdi-delete"
                                                        ></i>
                                                    </button>
                                                </td>
                                            </tr>
                                        </template>
                                    </tbody>
                                </table>
                                <button
                                    v-if="!createRango"
                                    @click="createRango = true"
                                    class="btn btn-primary btn-block"
                                >
                                    {{
                                        successMsg
                                            ? "Salir"
                                            : "Nuevo Rango de edades"
                                    }}
                                </button>
                                <button
                                    @click="clear()"
                                    class="btn btn-danger btn-block"
                                >
                                    {{ successMsg ? "Salir" : "Cancelar" }}
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import { required, minLength, between, email } from "vuelidate/lib/validators";
export default {
    props: ["a", "lang", "t"],
    mounted() {
        this.setFiltered();
    },
    data() {
        return {
            template: this.t,

            field: this.lang,
            selecting: {
                id: null
            },
            successMsg: null,
            createRango: null,
            agency: this.a,
            editing: null,
            rango: null,
            search: null,
            conUsuario: null,
            sinUsuario: null,
            newRango: {
                min: null,
                max: null
            },
            editarRangoEdad: {
                id: null,
                min: null,
                max: null
            }
        };
    },
    validations: {},
    methods: {
        setFiltered() {
            let a =
                JSON.parse(localStorage.getItem("aseguradora_selected")) ??
                null;
            if (a) {
                this.selecting.id = a.id;
                this.editing = a;
                this.getRangos(this.editing.id);
            }
        },
        selectAgency(ag) {
            this.editing = ag;
            localStorage.setItem("aseguradora_selected", JSON.stringify(ag));
            this.$emit("select-agency", ag);
            this.getRangos(this.editing.id);
        },
        clear() {
            this.newRango = { min: null, max: null };
            this.selecting.id = null;
            this.sinUsuario = null;
            this.editing = null;
            this.successMsg = null;
            this.user = {};
            this.errorMsg = null;
            this.createRango = null;
            this.rango = null;
            localStorage.removeItem("aseguradora_selected");
            this.$emit("select-agency", null);
        },
        getRangos(e) {
            return new Promise((res, rej) => {
                axios
                    .get("/api/aseguradora/rango", {
                        params: {
                            aseguradora: e
                        }
                    })
                    .then(response => {
                        this.rango = response.data;
                        res(true);
                        return false;
                    })
                    .catch(err => {
                        console.error(err);
                        rej(false);
                    });
            });
        },
        saveRango() {
            this.newRango.aseguradora_id = this.editing.id;
            axios
                .post("/api/aseguradora/rango", this.newRango)
                .then(res => {
                    this.createRango = false;
                    this.newRango = { min: null, max: null };
                    this.getRangos(this.editing.id);
                    return false;
                })
                .catch(err => {
                    console.error(err);
                });
        },
        postEditRango() {
            axios
                .put(
                    "/api/aseguradora/rango/" + this.editarRangoEdad.id,
                    this.editarRangoEdad
                )
                .then(res => {
                    this.editarRangoEdad = [];
                    this.getRangos(this.editing.id);
                    return false;
                })
                .catch(err => {
                    console.error(err);
                });
        },
        deleteRango(e) {
            axios
                .delete("/api/aseguradora/rango/" + e)
                .then(res => {
                    this.getRangos(this.editing.id);
                    return false;
                })
                .catch(err => {
                    console.error(err);
                });
        }
    }
};
</script>
